//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  clrDarkGreen
#property indicator_color2  clrCrimson 
#property indicator_color3  clrDarkGreen 
#property indicator_color4  clrCrimson
#property indicator_color5  clrCrimson
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2  // Heiken ashi trend biased (extreme) price
};

extern ENUM_TIMEFRAMES TimeFrame         = PERIOD_CURRENT;    // Time frame to use
extern int             GaussPeriod       = 50;                // Gaussian period
extern int             GaussOrder        = 4;                 // Gaussian order
extern enPrices        GaussPrice        = pr_close;          // Price to use
extern bool            alertsOn          = true;              // Turn alerts on?
extern bool            alertsOnCurrent   = false;             // Alerts on current (still opened) bar?
extern bool            alertsOnSlope     = true;              // Alerts on Slope change?
extern bool            alertsOnZeroCross = true;              // Alerts on zero cross?
extern bool            alertsMessage     = true;              // Alerts should display a message?
extern bool            alertsSound       = false;             // Alerts should play a sound?
extern bool            alertsNotify      = false;             // Alerts should send notification?
extern bool            alertsEmail       = false;             // Alerts should send an email?
extern string          soundFile         = "alert2.wav";      // Alerts sound file
extern bool            arrowsVisible     = true;              // Show arrows?
extern bool            arrowsOnFirst     = false;             // Show arrows on first mtf bar or the next?
extern bool            arrowsOnSlope     = true;              // Show arrows on slope change?
extern bool            arrowsOnZeroCross = false;             // Show arrows on zero cross?            
extern string          arrowsIdentifier  = "gausvel arrows1"; // Arrows ID
extern double          arrowsUpperGap    = 0.5;               // Arrows Upper Gap
extern double          arrowsLowerGap    = 0.5;               // Arrows lower gap
extern color           arrowsUpColor     = clrLimeGreen;      // Up arrow color
extern color           arrowsDnColor     = clrRed;            // Down arrows color
extern int             arrowsUpCode      = 241;               // Up arrow code
extern int             arrowsDnCode      = 242;               // Down arrow code
extern bool            arrowsUpSize      = 2;                 // Up arrow size
extern bool            arrowsDnSize      = 2;                 // Down arrow size
extern bool            Interpolate       = true;              // Interpolate in mtf mode

//
//
//
//
//

double UpH[];
double DnH[];
double vel[];
double velDna[];
double velDnb[];
double slope[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,UpH); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnH); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,vel);
   SetIndexBuffer(3,velDna);
   SetIndexBuffer(4,velDnb);
   SetIndexBuffer(5,trend);
   SetIndexBuffer(6,slope);
   
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = fmax(TimeFrame,_Period);
   
      IndicatorShortName(timeFrameToString(TimeFrame)+" gaussian velocity ("+(string)GaussPeriod+")");
return(0);
}
int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = fmin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpH[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
      if (trend[limit] ==-1) CleanPoint(limit,velDna,velDnb);
      for(i=limit; i>=0; i--)
      {
         if (i<Bars-1)
         {
           double price  = getPrice(GaussPrice,Open,Close,High,Low,i);
                  vel[i] = iGFilter(price,GaussPeriod,GaussOrder,i,0)-iGFilter(price,GaussPeriod,GaussOrder+1,i,1);
                  UpH[i]    = EMPTY_VALUE;
                  DnH[i]    = EMPTY_VALUE;
                  velDna[i] = EMPTY_VALUE;
                  velDnb[i] = EMPTY_VALUE;
                  slope[i]  = (i<Bars-1) ? (vel[i]>vel[i+1]) ? 1 : (vel[i]<vel[i+1]) ? -1 : slope[i+1] : 0;
                  trend[i]  = (i<Bars-1) ? (vel[i]>0)        ? 1 : (vel[i]<0)        ? -1 : trend[i+1] : 0;
                  if (slope[i] ==-1) PlotPoint(i,velDna,velDnb,vel);
                  if (trend[i] == 1) UpH[i] = vel[i];
                  if (trend[i] ==-1) DnH[i] = vel[i];
          }
          
          //
          //
          //
          //
          //
          
          if (arrowsVisible)
           {
              ObjectDelete(arrowsIdentifier+":1:"+(string)Time[i]);
              ObjectDelete(arrowsIdentifier+":2:"+(string)Time[i]);
              string lookFor = arrowsIdentifier+":"+(string)Time[i]; ObjectDelete(lookFor);
              if (i<(Bars-1) && arrowsOnSlope && slope[i] != slope[i+1])
              {
                if (slope[i] == 1) drawArrow("1",0.5,i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
                if (slope[i] ==-1) drawArrow("1",0.5,i,arrowsDnColor,arrowsDnCode,arrowsDnSize,true);
              }
              if (i<(Bars-1) && arrowsOnZeroCross && trend[i] != trend[i+1])
              {
                if (trend[i] == 1) drawArrow("2",1,i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
                if (trend[i] ==-1) drawArrow("2",1,i,arrowsDnColor,arrowsDnCode,arrowsDnSize,true);
              }
              
            }
      } 
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
         int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
         static datetime time1 = 0;
         static string   mess1 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] ==  1 ) doAlert(time1,mess1,whichBar,"sloping up");
            if (slope[whichBar] == -1 ) doAlert(time1,mess1,whichBar,"sloping down");
         }         
         static datetime time2 = 0;
         static string   mess2 = "";
         if (alertsOnZeroCross && trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1 ) doAlert(time2,mess2,whichBar,"crossing zero up");
            if (trend[whichBar] == -1 ) doAlert(time2,mess2,whichBar,"crossing zero down");
         }         
      }               
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)fmax(limit,fmin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (slope[limit] ==-1) CleanPoint(limit,velDna,velDnb);
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         UpH[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,GaussPeriod,GaussOrder,GaussPrice,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnZeroCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,0,y); 
         DnH[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,GaussPeriod,GaussOrder,GaussPrice,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnZeroCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,1,y); 
         vel[i]    = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,GaussPeriod,GaussOrder,GaussPrice,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnZeroCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,2,y); 
         slope[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,GaussPeriod,GaussOrder,GaussPrice,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,arrowsVisible,arrowsOnFirst,arrowsOnSlope,arrowsOnZeroCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,6,y); 
         velDna[i] = EMPTY_VALUE;
         velDnb[i] = EMPTY_VALUE;
         
         //
         //
         //
         //
         //
      
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
         //
         //
         //
         //
         //
                  
         int n,j; datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
            for(j = 1; j<n && (i+n)<Bars && (i+j)<Bars; j++)
            {
               vel[i+j] = vel[i] + (vel[i+n] - vel[i])*j/n;
               if (UpH[i]!= EMPTY_VALUE) UpH[i+j] = vel[i+j];
               if (DnH[i]!= EMPTY_VALUE) DnH[i+j] = vel[i+j];
            }        
   }
   for (i=limit;i>=0;i--) if (slope[i] ==-1) PlotPoint(i,velDna,velDnb,vel);           
return(0);       
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define gfInstances 2
int    periods[gfInstances];
double coeffs[][gfInstances*3];
double filters[][gfInstances];
double iGFilter(double price, int period, int order, int i, int instanceNo=0)
{
   if (ArrayRange(filters,0)!=Bars)  ArrayResize(filters,Bars);
   if (ArrayRange(coeffs,0)<order+1) ArrayResize(coeffs,order+1);
   if (periods[instanceNo]!=period)
   {
      periods[instanceNo]=period;
         double b = (1.0 - MathCos(2.0*M_PI/period))/(MathPow(MathSqrt(2.0),2.0/order) - 1.0);
         double a = -b + MathSqrt(b*b + 2.0*b);
         for(int r=0; r<=order; r++)
         {
             coeffs[r][instanceNo*3+0] = fact(order)/(fact(order-r)*fact(r));
             coeffs[r][instanceNo*3+1] = MathPow(    a,r);
             coeffs[r][instanceNo*3+2] = MathPow(1.0-a,r);
         }
   }

   //
   //
   //
   //
   //
   
   i = Bars-i-1;
   filters[i][instanceNo] = price*coeffs[order][instanceNo*3+1];
      double sign = 1;
         for (int r=1; r <= order && i-r>=0; r++, sign *= -1.0)
                  filters[i][instanceNo] += sign*coeffs[r][instanceNo*3+0]*coeffs[r][instanceNo*3+2]*filters[i-r][instanceNo];
   return(filters[i][instanceNo]);
}

//
//
//
//
//

double fact(int n)
{
   double a=1;
         for(int i=1; i<=n; i++) a*=i;
   return(a);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

#define priceInstances 1
double workHa[][priceInstances*4];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars); instanceNo*=4;
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = fmax(high[i], fmax(haOpen,haClose));
         double haLow   = fmin(low[i] , fmin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}   

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," gaussian velocity ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," gaussian velocity "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor, int theCode, int theWidth, bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+(string)Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      int add = 0; if (!arrowsOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_ARROW,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}
           

  

